/*************************************************************************\
    Copyright (c) 2010 Corporation for National Research Initiatives;
                        All rights reserved.
     The CNRI open source license for this software is available at 
                  http://hdl.handle.net/1895.26/1014
---------------------------------------------------------------------------
Developer: Sean Reilly <sreilly@cnri.reston.va.us>
\*************************************************************************/

package net.cnri.apps.doserver;

import net.cnri.knowbots.lib.*;
import java.io.*;
import java.security.*;


public class AgentSignerThread
  extends Thread
{
  private Signature sig;
  private String signerID;
  private InputStream in;
  private OutputStream out;
    
  AgentSignerThread(String signerID, Signature sig,
                    InputStream in, OutputStream out) {
    this.sig = sig;
    this.signerID = signerID;
    this.in = in;
    this.out = out;
  }

  public void run() {
    try {
      AgentStreamSigner signer = new AgentStreamSigner(signerID, sig);
      signer.signAgentStream(in, out);
    } catch (Exception e) {
      System.err.println("Error signing agent stream: "+e);
      e.printStackTrace(System.err);
    } finally {
      try { out.close(); } catch (Exception e) {}
    }
  }
}

